
      PROGRAM TDSYEV6
*
*       ணࠬ   PDSYEV6
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            LWORK, LIWORK, MAXN, LDA, MAXPROCS, NOUT
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 100, LWORK = 5592, LIWORK = 30,
     $                     MAXN = 100,
*      PARAMETER          ( LDA = 50, LWORK = -1, LIWORK = 30,
*     $                   MAXN = 50,
     $                   MAXPROCS = 64, NOUT =6, ZERO = 0.0D+0,
     $                   MONE = -1.0D+0 )
*
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*     ..
*  ६ ..
      INTEGER            CTXT, I, IAM, INFO, MYCOL, MYROW, N, NB,
     $                   NPCOL, NPROCS, NPROW, IA, JA, IZ, JZ, IL, IU
      DOUBLE PRECISION   ABSTOL
*     ..
*  ᨢ ..
      INTEGER            DESCA( 9 ), DESCZ( 9 ), IWORK(LIWORK),
     $                   IFAIL(4), ICLUSTR(8)
      DOUBLE PRECISION   A( LDA, LDA ), W( MAXN ), GAP(4),
     $                   WORK( LWORK ), Z( LDA, LDA ), WORK1( 4 )
*     $                   WORK( 264 ), Z( LDA, LDA ), WORK1( 4 )
*     ..
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PDLAPRNT,
     $                   PDSYEV6
*     ..
* 믮  ..
*
* ⠭ 
*
      N = 4
      NB = 2
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
      IZ = 1
      JZ = 1
      IL = 1
      IU = 3
      ORFAC = 0.0D0
*
* 樠  BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
* 樠 ⥪ BLACS'  ⪨ ᮢ
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨      ⥪,
* 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 20
      ABSTOL = 2.0D0* PDLAMCH(CTXT,'U')
*
* 樠 ਯ஢   A  Z
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
      CALL DESCINIT( DESCZ, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
* ஥  A
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO
         WRITE( NOUT, FMT = 9995 ) IL, IU
         WRITE( NOUT, FMT = 9993 ) ABSTOL, ORFAC
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCZ'
         WRITE( NOUT, FMT = 9985 )DESCZ
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
* 9984 FORMAT( / ' WORK(1) = ', D16.5, ' IWORK(1) = ',I6 /)
 9988 FORMAT( / ' UPLO = ', A /)
 9995 FORMAT( / ' IL =', I3, '   IU =', I3 / )
 9993 FORMAT( / ' ABSTOL =', D15.6, '   ORFAC =', D15.6 /)
*
      CALL PDLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
* ᫥ ᮡ⢥ 祭  ᮡ⢥ ஢
*
      CALL PDSYEV6( UPLO, N, A, IA, JA, DESCA, IL, IU, ABSTOL, M, NZ, W,
     $              ORFAC, Z, IZ, JZ, DESCZ, WORK, LWORK, IWORK, LIWORK,
     $              IFAIL, ICLUSTR, GAP, INFO )
*
*  १⮢
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = 9986 )M, NZ
*         WRITE( NOUT, FMT = 9984 )WORK(1), IWORK(1)
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ ᫠'
         DO 10 I = 1, M
            PRINT *, ' W(', I, ')=', W( I ), ';'
   10    CONTINUE
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ '
      END IF
*
*  ᮡ⢥ ஢
*
      CALL PDLAPRNT( N, M, Z, IZ, JZ, DESCZ, 0, 0, 'Z', NOUT, WORK1 )
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( 'W=diag([', 4D20.12, //']);' )
*
 9992 FORMAT( / '  ணࠬ PDSYEV6' )
 9998 FORMAT( / ' ᫥ ᮡ⢥ 祭  ᮡ⢥',
     $  ' ஢   A' /
     $       '  ࢠ ᮢ ( IL, IU ),' //
     $      '  A - ᨬ筠  ',
     $      I2, '  ', I2,',',
     $       ' ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I3 /)
 9986 FORMAT( / ' M =',I3, '     NZ =',I3 /)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
* PDMATINIT   ।  A  ⪥ ᮢ

      INTEGER            DLEN_, CTXT_
      PARAMETER          ( DLEN_ = 9, CTXT_ = 2 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
      INTEGER            IA, INFO, JA, N
      INTEGER            DESCA( * )
      DOUBLE PRECISION   A( * )
      INTEGER            I, J, MYCOL, MYROW, NPCOL, NPROW
      EXTERNAL           BLACS_GRIDINFO, PDELSET
      INTRINSIC          DBLE
*
      INFO = 0
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 20 J = 1, N
         DO 10 I = 1, N
            IF( I.EQ.J ) THEN
               CALL PDELSET( A, I, J, DESCA,
     $                       ( DBLE( N-I+1 ) ) / DBLE( N )+ONE /
     $                       ( DBLE( I+J )-ONE ) )
            ELSE
               CALL PDELSET( A, I, J, DESCA, ONE / ( DBLE( I+J )-ONE ) )
            END IF
   10    CONTINUE
   20 CONTINUE
*
      RETURN
*
*     End of PDMATINIT
*
      END
